#!/usr/bin/env python
"""
All the good names are taken ...

from http://www.python.org/doc/Humor.html

Cute Wabbit

Subject: Current Path
From: Nick Leaton <@calfp.co.uk>
Date: Wed, 04 Dec 1996 17:55:48 +0000
Message-Id: <32A5BB24.7690@calfp.co.uk>

Thanks to all that pointed out

	os.getcwd()


A little girl goes into a pet shop and asks for a wabbit. The shop
keeper looks down at her, smiles and says

"Would you like a lovely fluffy little white rabbit, or a cutesy
wootesly little brown rabbit"

"Actually", says the little girl, "I don't think my python would notice"
"""

# KDE classref docs at:
#     ftp://ftp.kde.com/pub/devel/kdeapidocs/kdeapidoc-cvs.tar.bz2


import os, os.path, sys, re, pwd

from qt import Qt, SIGNAL, SLOT, QApplication, QWidget, QMainWindow, QVBoxLayout, QTextBrowser, QSplitter, QToolBar, QAction,\
               QPixmap, QIconSet, QKeySequence, QTextEdit, QStyleSheetItem, QFontDialog, QPopupMenu, QVBoxLayout, QHBoxLayout,\
               QDialog, QPushButton, QSize, QColor, QPrinter, QPainter, QPaintDeviceMetrics, QRect, QSimpleRichText, QFont,\
               QString, QListBox, QPoint, QLabel, QLineEdit, QFileDialog, QMessageBox, QCheckBox

from reader import Reader
from genhtml import GenHTML, Popup

class Viewer (QMainWindow):
    def __init__ (self):
        QMainWindow.__init__ (self)

        self.config = {}

        if not self.readConfigFile ():
            sys.exit (1)

        IconPath = self.config ["wabbit"]
        try:
            KDERef = self.config ["KDERef"]
        except:
            KDERef = ""
            self.config ["KDERef"] = ""

        try:
            PyKDERef    = self.config ["PyKDERef"]
            PyKDEDocs   = self.config ["PyKDEDocs"]
            geom, sizes = self.getGeometry ()
        except:
            self.slotConfigActivated ()

        self.config ["mainWindow"] = self

        self.setGeometry (geom)

        self.setCaption ("wabbit")
        self.setIcon (QPixmap (os.path.join (IconPath, "wabbit1.png")))

        self.pyToolbar = QToolBar (self, "pytoolbar")
        self.moveDockWindow (self.pyToolbar, Qt.DockTop)

        self.pyBackAction = QAction ("Back", QIconSet (QPixmap (os.path.join (IconPath, "back.png"))),
                                "&Back", QKeySequence (), self, "back" )
        self.connect (self.pyBackAction, SIGNAL ("activated()") , self.slotPyBackActivated)
        self.pyBackAction.addTo (self.pyToolbar)

        self.pyFwdAction = QAction ("Forward", QIconSet (QPixmap (os.path.join (IconPath, "forward.png"))),
                               "&Forward", QKeySequence (), self, "forward" )
        self.connect (self.pyFwdAction, SIGNAL ("activated()") , self.slotPyFwdActivated)
        self.pyFwdAction.addTo (self.pyToolbar)

        self.pyToolbar.addSeparator ()

        self.pyFontAction = QAction ("Font", QIconSet (QPixmap (os.path.join (IconPath, "fonts.png"))),
                               "Fon&t", QKeySequence (), self, "fonts" )
        self.connect (self.pyFontAction, SIGNAL ("activated()") , self.slotPyFontActivated)
        self.pyFontAction.addTo (self.pyToolbar)

        self.pyToolbar.addSeparator ()
        self.pyToolbar.addSeparator ()

        self.pyPrintAction = QAction ("Print", QIconSet (QPixmap (os.path.join (IconPath, "print.png"))),
                               "&Print", QKeySequence (), self, "print" )
        self.connect (self.pyPrintAction, SIGNAL ("activated()") , self.slotPyPrintActivated)
        self.pyPrintAction.addTo (self.pyToolbar)

        self.pyToolbar.addSeparator ()
        self.pyToolbar.addSeparator ()

        self.pyBookAction = QAction ("Bookmarks", QIconSet (QPixmap (os.path.join (IconPath, "bookmark.png"))),
                               "Boo&kmark", QKeySequence (), self, "bookmark" )
        self.connect (self.pyBookAction, SIGNAL ("activated()") , self.slotPyBookActivated)
        self.pyBookAction.addTo (self.pyToolbar)

        self.pyToolbar.addSeparator ()
        self.pyToolbar.addSeparator ()

        pyQuitAction = QAction ("Quit", QIconSet (QPixmap (os.path.join (IconPath, "exit.png"))),
                               "&Quit", QKeySequence (), self, "quit" )
        self.connect (pyQuitAction, SIGNAL ("activated()") , self.slotPyQuitActivated)
        pyQuitAction.addTo (self.pyToolbar)

        self.configToolbar = QToolBar (self, "configtoolbar")
        self.moveDockWindow (self.configToolbar, Qt.DockTop)

        configAction = QAction ("Configure", QIconSet (QPixmap (os.path.join (IconPath, "configure.png"))),
                               "&Configure", QKeySequence (), self, "configure" )
        self.connect (configAction, SIGNAL ("activated()") , self.slotConfigActivated)
        configAction.addTo (self.configToolbar)

        htmlAction = QAction ("Write HTML Files", QIconSet (QPixmap (os.path.join (IconPath, "html.png"))),
                               "HTML", QKeySequence (), self, "html" )
        self.connect (htmlAction, SIGNAL ("activated()") , self.slotHTMLActivated)
        htmlAction.addTo (self.configToolbar)

        self.cppToolbar = QToolBar (self, "cpptoolbar")
        self.moveDockWindow (self.cppToolbar, Qt.DockBottom)

        self.cppBackAction = QAction( "Back", QIconSet (QPixmap (os.path.join (IconPath, "back.png"))),
                                 "&Back", QKeySequence (), self, "back" )
        self.connect (self.cppBackAction, SIGNAL ("activated()") , self.slotCppBackActivated)
        self.cppBackAction.addTo (self.cppToolbar)

        self.cppFwdAction = QAction( "Forward", QIconSet (QPixmap (os.path.join (IconPath, "forward.png"))),
                                      "&Forward", QKeySequence (), self, "forward" );
        self.connect (self.cppFwdAction, SIGNAL ("activated()") , self.slotCppFwdActivated)
        self.cppFwdAction.addTo (self.cppToolbar)

        self.cppToolbar.addSeparator ()

        self.cppFontAction = QAction ("Font", QIconSet (QPixmap (os.path.join (IconPath, "fonts.png"))),
                               "Fon&t", QKeySequence (), self, "fonts" )
        self.connect (self.cppFontAction, SIGNAL ("activated()") , self.slotCppFontActivated)
        self.cppFontAction.addTo (self.cppToolbar)

        self.cppToolbar.addSeparator ()
        self.cppToolbar.addSeparator ()

        self.cppPrintAction = QAction ("Print", QIconSet (QPixmap (os.path.join (IconPath, "print.png"))),
                               "&Print", QKeySequence (), self, "print" )
        self.connect (self.cppPrintAction, SIGNAL ("activated()") , self.slotCppPrintActivated)
        self.cppPrintAction.addTo (self.cppToolbar)

        self.cppToolbar.addSeparator ()
        self.cppToolbar.addSeparator ()

        self.cppBookAction = QAction ("Bookmarks", QIconSet (QPixmap (os.path.join (IconPath, "bookmark.png"))),
                               "Boo&kmark", QKeySequence (), self, "bookmark" )
        self.connect (self.cppBookAction, SIGNAL ("activated()") , self.slotCppBookActivated)
        self.cppBookAction.addTo (self.cppToolbar)

        self.split = QSplitter (QSplitter.Vertical, self)
        self.setCentralWidget (self.split)

        self.reader = Reader (os.path.join (PyKDERef, "classref.txt"), self.config)
        self.reader.readfile ()

        self.pyBrowser  = PyBrowser (self.reader, self.config, self.split)
        self.cppBrowser = CppBrowser (self.reader, self.config, self.split)
        self.split.setSizes (sizes)


        # if we underline links, then names with underscores ( _ ) are
        # unreadeable, for example 'pass_' or 'print_'

        self.pyBrowser.setLinkUnderline (False)
        self.cppBrowser.setLinkUnderline (False)

        self.pyBrowser.setCppBrowser (self.cppBrowser)
        self.pyBrowser.setSource ("home")

    def getGeometry (self):
        if self.config.has_key ("WabbitGeometry"):
            points = self.config ["WabbitGeometry"].split (",")
        else:
            points = None

        try:
            geom = QRect (int (points [0]), int (points [1]), int (points [2]), int (points [3]))
        except:
            geom = QRect (4, 20, 800, 600)

        if self.config.has_key ("SplitterPos"):
            sz = self.config ["SplitterPos"].split ()

        try:
            sizes = [int (sz [0]), int (sz [1])]
        except:
            sizes = [100, 100]

        return geom, sizes

    def printWindow (self, browser):
        self.printer = QPrinter ()
        self.printer.setFullPage (True)
        if self.printer.setup (self):
            p = QPainter (self.printer)
        else:
            return

        metrics = QPaintDeviceMetrics (p.device())
        dpix = metrics.logicalDpiX ()
        dpiy = metrics.logicalDpiY ()
        margin = 72

        body = QRect (margin*dpix/72, margin*dpiy/72,
                      metrics.width () - margin*dpix/72*2,
                      metrics.height () - margin*dpiy/72*2 )

        richText = QSimpleRichText (browser.text (), browser.font (), browser.context (), browser.styleSheet (),
                                  browser.mimeSourceFactory (), body.height ())
        richText.setWidth (p, body.width())

        view = QRect (body)
        page = 1

        while (True):
            richText.draw (p, body.left (), body.top (), view, self.colorGroup ())
            view.moveBy (0, body.height())

            p.translate (0, -body.height())
            p.drawText (view.right () - p.fontMetrics ().width (QString.number (page)),
                        view.bottom () + p.fontMetrics ().ascent () + 5, QString.number (page))

            if view.top () >= richText.height ():
                break

            self.printer.newPage ()
            page += 1

    def slotPyBackActivated (self):
        self.pyBrowser.back ()

    def slotPyFwdActivated (self):
        self.pyBrowser.fwd ()

    def slotPyFontActivated (self):
        font, ok = QFontDialog.getFont(self.pyBrowser.font())
        if ok:
            self.pyBrowser.setFont (font)

    def slotPyPrintActivated (self):
        self.printWindow (self.pyBrowser)

    def slotPyBookActivated (self):
        marks = Bookmarks (self.reader.pyBookmarks, "py", self, "")
        if marks.exec_loop ():
            self.pyBrowser.setSource (self.reader.pyBookmarks [marks.selected])

    def slotPyQuitActivated (self):
        QApplication.exit ()

    def slotAboutToQuit (self):
        try:
            pyFont = self.pyBrowser.currentFont ()
            cppFont = self.cppBrowser.currentFont ()
        except:
            pyFont = self.pyBrowser.font ()
            cppFont = self.cppBrowser.font ()

        self.config ["PyFont"]         = str (pyFont.family ())
        self.config ["PyFontSize"]     = str (pyFont.pointSize ())
        self.config ["PyFontWeight"]   = str (pyFont.weight ())
        self.config ["PyFontItalic"]   = str (pyFont.italic ())
        self.config ["CppFont"]        = str (cppFont.family ())
        self.config ["CppFontSize"]    = str (cppFont.pointSize ())
        self.config ["CppFontWeight"]  = str (cppFont.weight ())
        self.config ["CppFontItalic"]  = str (cppFont.italic ())
        geom = self.frameGeometry ()
        self.config ["WabbitGeometry"] = "%i, %i, %i, %i" % (geom.left (), geom.top (), geom.width (), geom.height ())
        splits = self.split.sizes ()
        self.config ["SplitterPos"]    = "%i %i" % (splits [0], splits [1])
        self.writeConfigFile ()

    def slotConfigActivated (self):
        cfgDlg = ConfigDlg (self)
        cfgDlg.setGeometry (100, 50, 300, 200)
        cfgDlg.exec_loop ()

    def slotHTMLActivated (self):
        htmlDlg = HTMLDlg (self)
        htmlDlg.setGeometry (100, 50, 300, 200)
        htmlDlg.exec_loop ()

    def slotCppBackActivated (self):
        self.cppBrowser.backward ()

    def slotCppFwdActivated (self):
        self.cppBrowser.forward ()

    def slotCppFontActivated (self):
        font, ok = QFontDialog.getFont(self.cppBrowser.font())
        if ok:
            self.cppBrowser.setFont (font)

    def slotCppPrintActivated (self):
        self.printWindow (self.cppBrowser)

    def slotCppBookActivated (self):
        marks = Bookmarks (self.reader.cppBookmarks, "cpp", self, "")
        if marks.exec_loop ():
            bookmark = os.path.join (self.config ["KDERef"], self.reader.cppBookmarks [marks.selected].split (":") [1])
            self.cppBrowser.setSource (bookmark)

    def getConfigFile (self):
        try:
            homepath = os.getenv ("HOME")
            if not homepath:
                homepath = pwd.getpwdnam (os.getlogin ()) [5]

            return os.path.join (homepath, ".wabbit", "wabbitrc")

        except:
            QMessageBox.critical (self,  "Error","Can't locate or read config file wabbitrc", QMessageBox.Ok, 0)
            return ""

    def readConfigFile (self):
        configFile = self.getConfigFile ()

        if not os.path.isfile (configFile):
            self.setDefaults ()
            self.slotConfigActivated ()
            if not os.path.isfile (configFile):
                sys.exit (0)

        if configFile and os.path.exists (configFile):
            self.config ["wabbit"] = os.path.dirname (configFile)
            f = open (configFile, "r")
            for line in f:
                if line.find ("="):
                    pair = line.split ("=")
                    if len (pair) >= 2:
                        self.config [pair [0].strip ()] = pair [1].strip ()
                    else:
                        self.config [pair [0].strip ()] = ""

            return True
        else:
            return False

    def setDefaults (self):
        self.config ["PyFont"]         = "Sans"
        self.config ["PyFontSize"]     = "10"
        self.config ["PyFontWeight"]   = "50"
        self.config ["PyFontItalic"]   = "0"
        self.config ["CppFont"]        = "Sans"
        self.config ["CppFontSize"]    = "10"
        self.config ["CppFontWeight"]  = "50"
        self.config ["CppFontItalic"]  = "0"
        self.config ["WabbitGeometry"] = "0, 0, 800, 600"
        self.config ["SplitterPos"]    = "100 100"


    def writeConfigFile (self):
        configFile = self.getConfigFile ()
        if not configFile:
            QMessageBox (self, "Error", "Unable to write configuration file", QMessageBox.Ok, 0)
            sys.exit (1)

        m = open (configFile + ".new", "w")
        m.write ("KDERef         = %s\n" % self.config ["KDERef"])
        m.write ("PyKDERef       = %s\n" % self.config ["PyKDERef"])
        m.write ("PyKDEDocs      = %s\n" % self.config ["PyKDEDocs"])
        m.write ("PyFont         = %s\n" % self.config ["PyFont"])
        m.write ("PyFontSize     = %s\n" % self.config ["PyFontSize"])
        m.write ("PyFontWeight   = %s\n" % self.config ["PyFontWeight"])
        m.write ("PyFontItalic   = %s\n" % self.config ["PyFontItalic"])
        m.write ("CppFont        = %s\n" % self.config ["CppFont"])
        m.write ("CppFontSize    = %s\n" % self.config ["CppFontSize"])
        m.write ("CppFontWeight  = %s\n" % self.config ["CppFontWeight"])
        m.write ("CppFontItalic  = %s\n" % self.config ["CppFontItalic"])
        m.write ("WabbitGeometry = %s\n" % self.config ["WabbitGeometry"])
        m.write ("SplitterPos    = %s\n" % self.config ["SplitterPos"])

        m.close ()
        if os.path.exists (configFile):
            os.unlink (configFile)
        os.rename (configFile + ".new", configFile)

class CppBrowser (QTextBrowser):
    def __init__ (self, reader, config, parent, name = None):
        QTextBrowser.__init__ (self, parent, name)
        self.config     = config
        self.reader     = reader
        self.mainWindow = config ["mainWindow"]

        self.restoreFont ()

    def restoreFont (self):
        try:
            f = self.currentFont ()
        except:
            f = self.font ()

        if self.config.has_key ("CppFont"):
            f.setFamily (self.config ["CppFont"])

        if self.config.has_key ("CppFontSize"):
            try:
                f.setPointSize (int (self.config ["CppFontSize"]))
            except:
                pass

        if self.config.has_key("CppFontWeight"):
            try:
                f.setWeight (int (self.config ["CppFontWeight"]))
            except:
                pass

        if self.config.has_key ("CppFontItalic"):
            try:
                f.setItalic (self.config ["CppFontItalic"] != "0")
            except:
                pass

        self.setFont (f)


    def createPopupMenu (self, p):
        parent = self.mainWindow
        IconPath = self.config ["wabbit"]

        self.ctxtMenu = QPopupMenu (self)

        parent.cppBackAction.addTo (self.ctxtMenu)
        parent.cppFwdAction.addTo (self.ctxtMenu)
        parent.cppFontAction.addTo (self.ctxtMenu)
        parent.cppBookAction.addTo (self.ctxtMenu)

        cppAddBookAction = QAction ("Add Bookmark", QIconSet (QPixmap (os.path.join (IconPath, "bookmark_add.png"))),
                                     "&Add Bookmark", QKeySequence (), self, "addBook" )
        self.connect (cppAddBookAction, SIGNAL ("activated()") , self.slotCppAddBookActivated)
        cppAddBookAction.addTo (self.ctxtMenu)

        return self.ctxtMenu

    def slotCppAddBookActivated (self):
        bookmark = self.getBookmark ().replace (self.config ["KDERef"] + os.sep, "")

        self.reader.cppBookmarks.append (":".join (["bookmark", bookmark]))
        self.reader.writeBookmarks ()

    def getBookmark (self):
        title_re = re.compile ("\<title\>.*\<\/title\>", re.I)
        title = title_re.search (str (self.text ()))
        if not title:
            return ":".join ([str (self.source ()), str (self.source ())])
        else:
            return ":".join ([str (self.source ()), str (self.text () [title.start () + 7:title.end () -8])])


class PyBrowser (QTextBrowser):
    def __init__ (self, reader, config, parent, name = None):
        QTextBrowser.__init__ (self, parent, name)
        self.stack        = []
        self.stackIdx     = 0
        self.currentPage  = ""
        self.reader       = reader
        self.cppBrowser   = None
        self.module       = ""
        self.cls          = ""
        self.config       = config
        self.mainWindow   = config ["mainWindow"]

        self.genHTML = GenHTML (reader, config)
        self.connect (self, SIGNAL ("contentsMoving (int, int)"), self.slotContentsMoving)
        self.prevX        = 0
        self.prevY        = 0
        self.notesEnabled = False

        self.restoreFont ()

    def restoreFont (self):
        try:
            f = self.currentFont ()
        except:
            f = self.font ()

        if self.config.has_key ("PyFont"):
            f.setFamily (self.config ["PyFont"])

        if self.config.has_key ("PyFontSize"):
            try:
                f.setPointSize (int (self.config ["PyFontSize"]))
            except:
                pass

        if self.config.has_key("PyFontWeight"):
            try:
                f.setWeight (int (self.config ["PyFontWeight"]))
            except:
                pass

        if self.config.has_key ("PyFontItalic"):
            try:
                f.setItalic (self.config ["PyFontItalic"] != "0")
            except:
                pass

        self.setFont (f)

    def setCppBrowser (self, browser):
        self.cppBrowser = browser

    def back (self):
        if self.stackIdx <= 0:
            return

        if self.stackIdx == len (self.stack):
            self.stack.append ((self.currentPage, self.contentsX (), self.contentsY ()))
        self.stackIdx -= 1
        mark, x, y = self.stack [self.stackIdx]
        self.setSource (mark, False)
        self.setContentsPos (x, y)

    def fwd (self):
        if self.stackIdx >= len (self.stack) - 1:
            return

        self.stackIdx += 1
        mark, x, y = self.stack [self.stackIdx]
        self.setSource (mark, False)
        self.setContentsPos (x, y)

    def setSource (self, name, clicked = True):
        KDERef  = self.config ["KDERef"]
        PyKDERef = self.config ["PyKDERef"]

        name = str (name)
        if clicked and self.currentPage and (self.currentPage != name)\
            and not name.startswith ("popup") and not name.find ("#") >= 0:
            if self.stackIdx < len (self.stack):
                del self.stack [self.stackIdx:]
            self.stack.append ((self.currentPage, self.contentsX (), self.contentsY ()))
            self.stackIdx = len (self.stack)

            self.currentPage = name

        if name.startswith ("home"):
            self.notesEnabled = False
            self.currentPage = "home"
            self.setText (self.genHTML.homePage ())
            self.moveCursor (QTextEdit.MoveHome, False)
            if KDERef and self.cppBrowser:
                self.cppBrowser.setSource (os.path.join (KDERef, "index.html"))

        elif name.startswith ("module"):
            self.notesEnabled = False
            self.module = name [9:]
            self.setText (self.genHTML.classesPage (self.module))
            self.moveCursor (QTextEdit.MoveHome, False)
            if KDERef and self.cppBrowser:
                self.cppBrowser.setSource (os.path.join (KDERef, self.module, "index.html"))

        elif name.startswith ("class"):
            self.notesEnabled = True
            self.cls = name [8:]
            self.setText (self.genHTML.classPage (self.module, self.cls))
            self.moveCursor (QTextEdit.MoveHome, False)
            if KDERef and self.cppBrowser:
                self.cppBrowser.setSource (os.path.join (KDERef, self.module, self.cls.replace (".", "__") + ".html"))

        elif name.startswith ("allclasses"):
            self.notesEnabled = False
            self.setText (self.genHTML.allClassesPage ())
            self.moveCursor (QTextEdit.MoveHome, False)

        elif name.startswith ("clsindex"):
            self.notesEnabled = False
            self.module, self.cls = name [11:].split ("+")
            self.setText (self.genHTML.classPage (self.module, self.cls))
            self.moveCursor (QTextEdit.MoveHome, False)
            if KDERef and self.cppBrowser:
                self.cppBrowser.setSource (os.path.join (KDERef, self.module, "index.html"))

        elif name.startswith ("global"):
            self.notesEnabled = True
            self.module = name [10:]
            self.setText (self.genHTML.globalPage (self.module))
            self.moveCursor (QTextEdit.MoveHome, False)
            if KDERef and self.cppBrowser:
                self.cppBrowser.setSource (os.path.join (KDERef, self.module, "all-globals.html"))

        elif name.startswith ("bookmark"):
            self.notesEnabled = True
            self.module, self.cls, anchor = name [9:].split (":")
            if self.cls:
                self.setText (self.genHTML.classPage (self.module, self.cls))
                if KDERef and self.cppBrowser:
                    self.cppBrowser.setSource (os.path.join (KDERef, self.module, self.cls.replace (".", "__") + ".html"))
            else:
                self.setText (self.genHtml.globalPage (self.module))
                if KDERef and self.cppBrowser:
                    self.cppBrowser.setSource (os.path.join (KDERef, self.module, "all-globals.html"))

            self.scrollToAnchor (anchor)

        elif name.startswith ("popup"):
            self.notesEnabled = False
            pname = name [8:]
            popfile = "file:" + os.sep + os.path.join (PyKDERef, "glossary.html#%s" % pname)
            popupDlg = Popup (popfile, self)
            popupDlg.setGeometry (self.width ()/2 + self.x () - 50, self.y () + 50, self.width ()/2, self.height ())
            popupDlg.show ()
            self.setContentsPos (self.prevX, self.prevY)

        elif name.find ("html#") > 0 and self.cppBrowser:
            if KDERef and self.cppBrowser:
                self.cppBrowser.setSource (name)

        else:
            QTextBrowser.setSource (self, name)

    def slotContentsMoving (self, x, y):
        self.prevX = self.contentsX ()
        self.prevY = self.contentsY ()

    def slotPyNoteActivated (self):
        para = self.paragraphAt (self.popPt)
        txt = str (self.text (para))

        meth_re = re.compile ('\#\w*\"')
        meth = meth_re.search (txt)

        if not meth:
            return

        method = txt [meth.start () + 1:meth.end () - 1]
        key = ":".join ([self.module, self.cls, method])

        if key in self.reader.notes:
            currentText = self.reader.notes [key]
        else:
            currentText = ""

        noteDlg = NotePopup (currentText, self)
        noteDlg.setGeometry (self.width ()/2 + self.x () - 50, self.y () + 50, self.width ()/2 + 20, self.height ())
        result = noteDlg.exec_loop ()
        if result:
            note = str (noteDlg.popupEdit.text ())
            if note:
                self.reader.notes [key] = note
            elif key in self.reader.notes:
                del self.reader.notes [key]
            self.reader.writeNotes ()

            x = self.contentsX ()
            y = self.contentsY ()
            self.setSource (self.currentPage)
            self.setContentsPos (x, y)

    def slotPyAddBookActivated (self):
        self.reader.pyBookmarks.append (":".join (["bookmark", self.getBookmark ()]))
        self.reader.writeBookmarks ()

    def createPopupMenu (self, p):
        self.popPt = p
        parent = self.mainWindow
        IconPath = self.config ["wabbit"]

        self.ctxtMenu = QPopupMenu (self)

        parent.pyBackAction.addTo (self.ctxtMenu)
        parent.pyFwdAction.addTo (self.ctxtMenu)
        parent.pyFontAction.addTo (self.ctxtMenu)
        parent.pyBookAction.addTo (self.ctxtMenu)

        pyAddBookAction = QAction ("Add Bookmark", QIconSet (QPixmap (os.path.join (IconPath, "bookmark_add.png"))),
                                     "&Add Bookmark", QKeySequence (), self, "addBook" )
        self.connect (pyAddBookAction, SIGNAL ("activated()") , self.slotPyAddBookActivated)
        pyAddBookAction.addTo (self.ctxtMenu)

        pyNoteAction = QAction ("Note", QIconSet (QPixmap (os.path.join (IconPath, "note.png"))),
                                     "&Annotate", QKeySequence (), self, "note" )
        self.connect (pyNoteAction, SIGNAL ("activated()") , self.slotPyNoteActivated)
        pyNoteAction.addTo (self.ctxtMenu)

        para = self.paragraphAt (p)
        if para == 0 or not self.notesEnabled:
            pyNoteAction.setEnabled (False)
            pyAddBookAction.setEnabled (False)
        else:
            pyNoteAction.setEnabled (True)
            pyAddBookAction.setEnabled (True)

        return self.ctxtMenu

    def getBookmark (self):
        return ":".join ([self.module, self.cls, str (self.anchorAt (self.popPt, Qt.AnchorName))])


class Bookmarks (QDialog):
    def __init__ (self, marklist, browserType, parent, name = ""):
        QDialog.__init__ (self, parent, name, True)
        self.setCaption ("Bookmarks")

        self.selected    = -1
        self.browserType = browserType
        self.marklist    = marklist

        popupLayout = QVBoxLayout(self,5,6)
        self.marks = QListBox (self)
        if self.browserType == "cpp":
            for mark in marklist:
                self.marks.insertItem (mark.split (":", 2) [2])
        elif browserType == "py":
            for mark in marklist:
                self.marks.insertItem (mark.split (":", 2) [2].replace (":", "."))
        self.connect (self.marks, SIGNAL ("mouseButtonPressed (int, QListBoxItem *, const QPoint &)"), self.slotMouseButton)
        popupLayout.addWidget(self.marks)

        self.closeBtn = QPushButton("close", self)
        self.closeBtn.setMaximumSize(QSize(70,25))
        self.connect (self.closeBtn, SIGNAL ("clicked ()"), self.slotCloseClicked)
        popupLayout.addWidget(self.closeBtn)

    def slotCloseClicked (self):
        self.done (0)

    def slotMouseButton (self, button, item, pos):
        if button == 1 and item:
            self.selected = self.marks.index (item)
            self.done (1)
        elif button == 2:
            self.menu = QPopupMenu (self)
            self.item = item
            self.pos  = pos
            self.menu.insertItem ("Delete", self.slotDeleteBookmark)
            self.menu.popup (pos + QPoint (0, 15))


    def slotDeleteBookmark (self):
        del self.marklist [self.marks.index (self.item)]
        self.parent ().reader.writeBookmarks ()

#need to re-assemble name from list ???
        self.done (0)

class NotePopup (QDialog):
    def __init__ (self, text, parent, name = ""):
        QDialog.__init__ (self, parent, name, True)
        self.setCaption ("Note")

        popupLayout = QVBoxLayout(self,5,6)

        self.popupEdit = QTextEdit(self)
        self.popupEdit.setText (text)
        self.popupEdit.setPaletteBackgroundColor (QColor (0xff, 0xff, 0xc0))
        popupLayout.addWidget(self.popupEdit)

        btnLayout = QHBoxLayout (None, 5, 6)
        popupLayout.addLayout (btnLayout)

        self.closeBtn = QPushButton("close", self)
        self.closeBtn.setMaximumSize(QSize(70,25))
        self.connect (self.closeBtn, SIGNAL ("clicked ()"), self.slotCloseClicked)
        btnLayout.addWidget(self.closeBtn)

        self.saveBtn = QPushButton("save", self)
        self.saveBtn.setMaximumSize(QSize(70,25))
        self.connect (self.saveBtn, SIGNAL ("clicked ()"), self.slotSaveClicked)
        btnLayout.addWidget(self.saveBtn)

        self.clearWState(Qt.WState_Polished)

    def slotCloseClicked (self):
        self.done (0)

    def slotSaveClicked (self):
        self.done (1)

class ConfigDlg (QDialog):
    def __init__ (self, parent, name = ""):
        QDialog.__init__ (self, parent, name, True)
        self.setCaption ("wabbit Configuration")

        self.dlgLayout = QVBoxLayout(self,5,6)

        kdeRefLbl = QLabel ("Path to KDE ClassRef", self)
        self.dlgLayout.addWidget (kdeRefLbl)
        kdeRefLayout = QHBoxLayout (None, 5, 6)
        self.dlgLayout.addLayout (kdeRefLayout)
        self.kdeRef = QLineEdit (self)
        if self.parent ().config.has_key ("KDERef"):
            self.kdeRef.setText (self.parent ().config ["KDERef"])
        kdeRefLayout.addWidget (self.kdeRef)
        kdeRefBtn = QPushButton ("...", self)
        kdeRefLayout.addWidget (kdeRefBtn)
        self.connect (kdeRefBtn, SIGNAL ("clicked ()"), self.slotKDERefClicked)

        pyKDERefLbl = QLabel ("Path to PyKDE ClassRef", self)
        self.dlgLayout.addWidget (pyKDERefLbl)
        pyKDERefLayout = QHBoxLayout (None, 5, 6)
        self.dlgLayout.addLayout (pyKDERefLayout)
        self.pyKDERef = QLineEdit (self)
        if self.parent ().config.has_key ("PyKDERef"):
            self.pyKDERef.setText (self.parent ().config ["PyKDERef"])
        pyKDERefLayout.addWidget (self.pyKDERef)
        pyKDERefBtn = QPushButton ("...", self)
        pyKDERefLayout.addWidget (pyKDERefBtn)
        self.connect (pyKDERefBtn, SIGNAL ("clicked ()"), self.slotPyKDERefClicked)

        pyKDEDocLbl = QLabel ("Path to PyKDE Docs", self)
        self.dlgLayout.addWidget (pyKDEDocLbl)
        pyKDEDocLayout = QHBoxLayout (None, 5, 6)
        self.dlgLayout.addLayout (pyKDEDocLayout)
        self.pyKDEDoc = QLineEdit (self)
        if self.parent ().config.has_key ("PyKDEDocs"):
            self.pyKDEDoc.setText (self.parent ().config ["PyKDEDocs"])
        pyKDEDocLayout.addWidget (self.pyKDEDoc)
        pyKDEDocBtn = QPushButton ("...", self)
        pyKDEDocLayout.addWidget (pyKDEDocBtn)
        self.connect (pyKDEDocBtn, SIGNAL ("clicked ()"), self.slotPyKDEDocClicked)


        btnLayout = QHBoxLayout (None, 5, 6)
        self.dlgLayout.addLayout (btnLayout)

        self.closeBtn = QPushButton("close", self)
        self.closeBtn.setMaximumSize(QSize(70,25))
        self.connect (self.closeBtn, SIGNAL ("clicked ()"), self.slotCloseClicked)
        btnLayout.addWidget(self.closeBtn)

        self.saveBtn = QPushButton("save", self)
        self.saveBtn.setMaximumSize(QSize(70,25))
        self.connect (self.saveBtn, SIGNAL ("clicked ()"), self.slotSaveClicked)
        btnLayout.addWidget(self.saveBtn)

        self.clearWState(Qt.WState_Polished)
        self.items = 7

    def slotCloseClicked (self):
        self.done (0)

    def slotSaveClicked (self):
        kref  = str (self.kdeRef.text ())
        pyref = str (self.pyKDERef.text ())
        pydoc = str (self.pyKDEDoc.text ())

        if not (pyref and pydoc):
            QMessageBox.critical (self, "Error", "You must provide paths to both the PyKDE class ref and PyKDEDocs",\
                QMessageBox.Ok, 0)
            return

        self.parent ().config ["KDERef"] = kref
        self.parent ().config ["PyKDERef"] = pyref
        self.parent ().config ["PyKDEDocs"] = pydoc

        self.parent ().writeConfigFile ()

        self.done (1)

    def slotKDERefClicked (self):
        self.getPath (self.kdeRef)

    def slotPyKDERefClicked (self):
        self.getPath (self.pyKDERef)

    def slotPyKDEDocClicked (self):
        self.getPath (self.pyKDEDoc)

    def getPath (self, edit):
        if os.path.isdir (str (edit.text ())):
            startDir = edit.text ()
        else:
            startDir = "/"

        result = QFileDialog.getExistingDirectory (startDir, self, "", "Choose Directory", False, True)
        if result:
            edit.setText (result)

class HTMLDlg (ConfigDlg):
    def __init__ (self, parent, name = ""):
        ConfigDlg.__init__ (self, parent, name)
        self.setCaption ("Write HTML")

        self.webCB = QCheckBox ("Use internet links for KDE", self)
        self.webCB.setChecked (False)
        self.dlgLayout.insertWidget (self.items - 1, self.webCB)

    def slotCloseClicked (self):
        self.done (0)

    def slotSaveClicked (self):
        kref  = str (self.kdeRef.text ())
        pyref = str (self.pyKDERef.text ())
        pydoc = str (self.pyKDEDoc.text ())

        configFile = self.parent ().getConfigFile ()
        if not configFile:
            self.done (-1)

        config               = {}
        config ["wabbit"]    = configFile.replace ("wabbitrc", "")
        if self.webCB.isChecked ():
            config ["WebLink"] = True
            config ["KDERef"]  = "http://developer.kde.org/documentation/library/cvs-api/"
        else:
            config ["WebLink"] = False
            config ["KDERef"]  = kref
        config ["PyKDERef"]  =  pyref
        config ["PyKDEDocs"] =  pydoc

        try:
            import dumphtml
        except:
            QMessageBox.critical (self, "Error", "Couldn't load dumphtml module to write html files", QMessageBox.Ok, 0)
            self.done (-1)

        dest = os.path.join (pydoc, "classref")
        if not os.path.isdir (dest):
            try:
                os.mkdir (dest)
            except:
                QMessageBox.critical (self, "Error", "Couldn't create %s directory" % dest, QMessageBox.Ok, 0)
                self.done (-1)

        dumphtml.writeHTMLFiles (config, dest)

        self.done (1)

if __name__ == "__main__":

    app = QApplication(sys.argv)
    viewer = Viewer ()
    viewer.connect (app, SIGNAL ("aboutToQuit ()"), viewer.slotAboutToQuit)
#    viewer.resize(800,600)
    app.setMainWidget(viewer)
    viewer.show()
    app.exec_loop()
